// Code generated by mockery v2.39.1. DO NOT EDIT.

package mocks

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/timofeev.pavel.art/wallet/internal/models"
)

// CategoryProvider is an autogenerated mock type for the CategoryProvider type
type CategoryProvider struct {
	mock.Mock
}

// CreateCategory provides a mock function with given fields: ctx, category
func (_m *CategoryProvider) CreateCategory(ctx context.Context, category models.Category) error {
	ret := _m.Called(ctx, category)

	if len(ret) == 0 {
		panic("no return value specified for CreateCategory")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, models.Category) error); ok {
		r0 = rf(ctx, category)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// DeleteCategoryByID provides a mock function with given fields: ctx, categoryID
func (_m *CategoryProvider) DeleteCategoryByID(ctx context.Context, categoryID int) error {
	ret := _m.Called(ctx, categoryID)

	if len(ret) == 0 {
		panic("no return value specified for DeleteCategoryByID")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, int) error); ok {
		r0 = rf(ctx, categoryID)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetCategoryByID provides a mock function with given fields: ctx, categoryID
func (_m *CategoryProvider) GetCategoryByID(ctx context.Context, categoryID int) (models.Category, error) {
	ret := _m.Called(ctx, categoryID)

	if len(ret) == 0 {
		panic("no return value specified for GetCategoryByID")
	}

	var r0 models.Category
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, int) (models.Category, error)); ok {
		return rf(ctx, categoryID)
	}
	if rf, ok := ret.Get(0).(func(context.Context, int) models.Category); ok {
		r0 = rf(ctx, categoryID)
	} else {
		r0 = ret.Get(0).(models.Category)
	}

	if rf, ok := ret.Get(1).(func(context.Context, int) error); ok {
		r1 = rf(ctx, categoryID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategoryList provides a mock function with given fields: ctx
func (_m *CategoryProvider) GetCategoryList(ctx context.Context) ([]models.Category, error) {
	ret := _m.Called(ctx)

	if len(ret) == 0 {
		panic("no return value specified for GetCategoryList")
	}

	var r0 []models.Category
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context) ([]models.Category, error)); ok {
		return rf(ctx)
	}
	if rf, ok := ret.Get(0).(func(context.Context) []models.Category); ok {
		r0 = rf(ctx)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]models.Category)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateCategoryByID provides a mock function with given fields: ctx, id, category
func (_m *CategoryProvider) UpdateCategoryByID(ctx context.Context, id int, category models.Category) error {
	ret := _m.Called(ctx, id, category)

	if len(ret) == 0 {
		panic("no return value specified for UpdateCategoryByID")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, int, models.Category) error); ok {
		r0 = rf(ctx, id, category)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewCategoryProvider creates a new instance of CategoryProvider. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewCategoryProvider(t interface {
	mock.TestingT
	Cleanup(func())
}) *CategoryProvider {
	mock := &CategoryProvider{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
